% alex_read_plot_data_from_ctd_matfile_years_2003_2019.m

clear;

% Data path - part:
% path_name_part ='';
path_name_part ='~/alex_CTD_matfiles_and_txt/CTD_matfiles_2003_2019/matfiles/';

plot_location='yes';
%plot_location='no';

plot_id='-';
plot_color=[0 0 1];
fnt_axes=9;
fnt_label=10;
fnt_title=10;
line_width=0.8;

%@@@@@@@@@@@@@@@@@@@@@@@@@@
% ---- MENU: Year
%@@@@@@@@@@@@@@@@@@@@@@@@@@
year=f_menu_of_numbers_title('YEAR',[2003 2004 2005 2006 2007 2008 2009 2010 2012 2013 2014 2015 2016 2017 2018 2019]);
if isempty(year), return; end
%@@@@@@@@@@@@@@@@@@@@@@@@@@
switch year
    case 2003
        cr_list=strvcat('oc391');
    case 2004
        cr_list=strvcat('oc402');
    case 2005
        cr_list=strvcat('oc412','ti096','ti098','ti100','ti103','ti105','ti109','ti112');
    case 2006
        cr_list=strvcat('oc425','ti171','ti177','ti180','ti181','ti184','ti185','ti191','bold_07_06');
    case 2007
        cr_list=strvcat('en435','en437','ti229','ti239','ti245','ti261');
    case 2008
        cr_list=strvcat('oc445','oc447','en448','en451','ti303','ti313','ti314','ti326');
    case 2009
        cr_list=strvcat('ti383','ti386');
    case 2010
        cr_list=strvcat('oc460','oc465','oc467','en476');
    case 2012
        cr_list=strvcat('ti603','ti606','ti623');
    case 2013
        cr_list=strvcat('ti661','ti667','ti670','ti672','ti677','ti691');
    case 2014
        cr_list=strvcat('ti747','ti751','ti752','ti758','ti762','ti770');
    case 2015
        cr_list=strvcat('ct01','ti813','ti817','ti831','ct04');
    case 2016
        cr_list=strvcat('ct01','ct02','gc01','ti906');
    case 2017
        cr_list=strvcat('WJ01','ti972','ti972_SBE19','ti978');
    case 2018
        cr_list=strvcat('ct01','ct02');
    case 2019
        cr_list=strvcat('ct01','ct02','ct03');
end
%@@@@@@@@@@@@@@@@@@@@@@@@@@
% ---- MENU: Cruise ID
%@@@@@@@@@@@@@@@@@@@@@@@@@@
cr_id=f_menu_of_strings('Cruise',cr_list);
if isempty(cr_id), return; end
%@@@@@@@@@@@@@@@@@@@@@@@@@@
%======================================================================
%==========================  READ MATFILE   ===========================
%======================================================================
%=================================
% MATFILE name and path.
%=================================
fname=[cr_id '_ctd_profiles'];
path_name =[path_name_part num2str(year) '/'];
%=================================
%  LOAD MATAFILE.
%=================================
p=['load ' path_name fname '.mat;'];
eval(p);
% MATFILE variables (e.g. 2008 TI303):
% whos
%  bad_flag                       1x1                  8  double
%  data                        1619x15            194280  double
%  data_columns                  15x49              1470  char
%  info_ctd_casts                28x9               2016  double
%  info_ctd_casts_columns         9x36               648  char
%==========================
% (1) Variable "data": CTD data profiles.
%==========================
d=data;
clear data;
size(d)
colSt=1;
colPres=3;
%==========================
% (2) Variable "info_ctd_casts": CTD navigation data.
%==========================
c_list=info_ctd_casts;
%==========================
% (3) Variable "data_columns": CTD data columns## and names.
%==========================
% E.g.: 2008 TI303 Variable "data_columns":
% data_columns =
%  15×57 char array
%    '01 - Station #                                   '
%    '02 - Time, Elapsed [seconds]                     '
%    '03 - Pressure (db)                               '
%    '04 - Temperature Prim (deg C)                    '
%    '05 - Conductivity Prim (S/m)                     '
%    '06 - Fluorescence, WET Labs WETstar (mg/m^3)     '
%    '07 - Beam Transmission, Chelsea/Seatech/Wetlab CStar (%)                            '
%    '08 - Altimeter (m)                               '
%    '09 - Seapoint Turbidity (FTU)                    '
%    '10 - Irradiance PAR (mkE m^-^2 sec^-^1)          '
%    '11 - Surface Irradiance SPAR (mkE m^-^2 sec^-^1) '
%    '12 - Oxygen Prim (volt)                          '
%    '13 - Oxygen Prim (ml/L)                          '
%    '14 - Salinity Prim                               '
%    '15 - Density Prim (sigma-theta, kg/m^3)          '
%@@@@@@@@@@@@@@@@@@@@@@@@@@
% ---- MENU: PARAMETER
%@@@@@@@@@@@@@@@@@@@@@@@@@@
col_par=f_menu_of_strings('PARAMETER: column# and name',data_columns);
if isempty(col_par), return; end
%@@@@@@@@@@@@@@@@@@@@@@@@@@
[col_num_str,par_name]=strtok(col_par,'-');
% Parameter column# and name.
col_num=str2double(col_num_str);
par_name=deblank(par_name(3:end));
%==========================
% Variable "info_ctd_casts_columns": CTD navigation data.
%==========================
% whos (e.g. 2008 TI303):
% info_ctd_casts_columns =
%  9×36 char array
%    'col_st=1 : CTD Cast #               '
%    'col_year=2 : Year                   '
%    'col_month=3 : Month                 '
%    'col_day=4 : UTC Hour                '
%    'col_hour=5 : Minute                 '
%    'col_min=6 : UTC Minute              '
%    'col_sec=7 : UTC Second              '
%    'col_lat=8 : Latitude (decimal DegN) '
%    'col_lon=9 : Longitude (decimal DegW)'
%==========================
% Navigation: Evaluate this variable to have new variables in workspace - navigation data column #.
%==========================
for ii=1:size(info_ctd_casts_columns,1)
    info_i=info_ctd_casts_columns(ii,:);
    [col_num_str,par_name_nav]=strtok(info_i,':');
    eval([col_num_str ';']);
end
clear par_name_nav col_num_str;
% Resulting variables - navigation data columns:
%    col_st=1;             '
%    col_year=2;
%    col_month=3;
%    col_day=4;
%    col_hour=5;
%    col_min=6;
%    col_sec=7;
%    col_lat=8;
%    col_lon=9;
% Two more column for bold_07_06
%    'col_bold_id=10 : Bold CTD station ID - 1-CTD, 2-TS, 3-MH, 4-KC, 6-CTD2_, 7-TS1_, 8-MH6_up_'
%    'col_bold_st=11 : Bold CTD station #                                                       '
%==========================
% CTD stations list.
%==========================
ctdList=unique(c_list(:,col_st))';
total_stations=length(ctdList);
%@@@@@@@@@@@@@@@@@@@@@@@@@@
% ---- MENU: STATION #
%@@@@@@@@@@@@@@@@@@@@@@@@@@
% Plot one of the stations on the top.
stNum_show=f_menu_of_numbers_title('Station #',ctdList);
if isempty(stNum_show), return; end
%==========================
% CTD stations name.
%==========================
if year==2006 & strcmp(cr_id,'bold_07_06')
    rst=find(c_list(:,col_st)==stNum_show);
    bold_id=c_list(rst,col_bold_id);
    bold_st=c_list(rst,col_bold_st);
    switch bold_id
        case 1
            bold_id_str='CTD';
        case 2
            bold_id_str='TS';
        case 3
            bold_id_str='MH';
        case 4
            bold_id_str='KC';
        case 6
            bold_id_str='CTD2_';
        case 7
            bold_id_str='TS1_';
        case 8
            bold_id_str='MH6_up_';
    end
    %    'col_bold_id=10 : Bold CTD station ID - 1-CTD, 2-TS, 3-MH, 4-KC, 6-CTD2_, 7-TS1_, 8-MH6_up_'
    %    'col_bold_st=11 : Bold CTD station #                                                       '
    st_name=[' (' bold_id_str num2str(bold_st) ')'];
else
    st_name='';
end
%**************************************************************************
%**************************   CRUISE DATE/TIME   **************************
%**************************************************************************
date_matr=c_list(:,[col_year col_month col_day col_hour col_min col_sec]);
date_num=datenum(date_matr);
date_s=datestr(min(date_num));
date_e=datestr(max(date_num));
%**************************************************************************
%**************************   STATION DATE/TIME  **************************
%**************************************************************************
r_st=find(c_list(:,col_st)==stNum_show);
date_st_matr=c_list(r_st,[col_year col_month col_day col_hour col_min col_sec]);
date_st_num=datenum(date_st_matr);
date_st=datestr(date_st_num);
%==========================================================================
%=========================    PLOT DATA PROFILES ==========================
%==========================================================================
figure;
set(gcf,'color',[1 1 1],'position',[408.00        260.00        638.00        657.00],...
    'paperPositionMode','auto');
str_disp='"BAD" DATA INFO:';
min_max_info=[];
str_leg='';
countPlot=0;
hold on;
for stNum=ctdList
    %colNum_d=colNum_matf;
    rr_st=find(d(:,colSt)==stNum);
    presSt=d(rr_st,colPres);
    % Current station quantity.
    parSt=d(rr_st,col_num);
    % Find and remove "bad" data.
    r_bad=find(parSt(:,1)==bad_flag);
    if ~isempty(r_bad)
        str_disp=strvcat(str_disp,['Station No ' num2str(stNum) ', ' par_name ': ' num2str(length(r_bad)) ' line(s) with "bad" data (flag=-9.990e-29)'],...
            'Pressure  Quantity',num2str([presSt(r_bad,:) parSt(r_bad,:)]));
        parSt(r_bad,:)=nan;
        presSt(r_bad,:)=nan;
    end
    if stNum==stNum_show
        parSt_show= parSt;
        presSt_show=presSt;
    end
    %**************************************************************************
    %***********************  Plot profiles - all  ****************************
    %**************************************************************************
    countPlot=countPlot+1;
    if countPlot==1
        hhh(1)=plot(parSt,presSt,plot_id,'color',plot_color,'linewidth',line_width);
        str_leg=strvcat(str_leg,['ALL stations, total: ' num2str(total_stations)]);
    else
        plot(parSt,presSt,plot_id,'color',plot_color,'linewidth',line_width);
    end
    %**************************************************************************
    %***************     Min, Max info - for Axes limits   ********************
    %**************************************************************************
    min_max_info=[min_max_info;min(parSt) max(parSt) min(presSt) max(presSt)];
    min_max_info=[min_max_info;min(parSt) max(parSt) min(presSt) max(presSt)];
end % For for stNum=ctdList
    %**************************************************************************
    %************************  Plot profile - selected station ****************
    %**************************************************************************
rnan=find(isnan(parSt_show));
if length(rnan)==length(parSt_show)
    disp(['Station ' num2str(stNum_show) ' ' par_name ' is not available']);
else
    hhh(2)=plot(parSt_show,presSt_show,'--','color',[1 0 0],'linewidth',line_width+0.5);
    str_leg=strvcat(str_leg,['Station #' num2str(stNum_show)]);
end
hold off;
%**************************************************************************
%*******************************    AXES LIMITS   *************************
%**************************************************************************
par_range=[min(min_max_info(:,1)) max(min_max_info(:,2))];
pres_range=[min(min_max_info(:,3)) max(min_max_info(:,4))];
if min(parSt)==0
    x_lim_1=0;
else
    x_lim_1=par_range(1)-0.05*range(par_range);
end
x_lim_2 = par_range(2)+0.05*range(par_range);
x_lim=[x_lim_1 x_lim_2];
y_lim_1=0;
y_lim_2 = pres_range(2)+0.05*range(pres_range);
y_lim=[y_lim_1 y_lim_2];
if x_lim(1)==x_lim(2), x_lim=[x_lim(1)-0.5 x_lim(1)+0.5]; end
% Set Axes limits.
axis([x_lim y_lim]);
%**************************************************************************
%****************************    AXES PROPERTIES   ************************
%**************************************************************************
grid on;
set(gca,'ydir','reverse','fontsize',fnt_axes,'box','on');
xlabel(par_name,'fontsize',fnt_label);
ylabel('Pressure (db)','fontsize',fnt_label);
cruise_title=strrep(upper(cr_id),'_','\_');
str_title(1)={[cruise_title ': ' date_s ' - ' date_e ' (' strrep(fname,'_','\_') '.mat)']};
str_title(2)={['Station ' num2str(stNum_show) st_name ': ' date_st]};
title(str_title,'fontsize',fnt_title,'color',[0 0 1],'fontweight','normal');
hl=legend(hhh,str_leg,'Location','southeast');
% Change axes position.
ah=get(gca,'position');
set(gca,'position',[ah(1)+0.02*ah(3) ah(2)-0*ah(4) ah(3) ah(4)*0.95]);
% Display "bad" data - marked with bad_flag=-9.99e-29
%if size(str_disp,1)>1
%    disp(str_disp);
%end
%**************************************************************************
%********************    PLOT stations locations   ************************
%**************************************************************************
if strcmp(plot_location,'yes')
    figure;
    plot(c_list(:,col_lon),c_list(:,col_lat),'b+','markersize',5)
    set(gca,'xdir','reverse');
    if ~isempty(stNum_show)
        rc=find(c_list(:,col_st)==stNum_show);
        hold on;
        plot(c_list(rc,col_lon),c_list(rc,col_lat),'r+','markersize',8);
        hold off;
        xlabel('Longitude (degW)');
        ylabel('Latitude (degN)');
        title([num2str(year) ' ' cr_id ': total  ' num2str(total_stations) ' stations, marked station # ' num2str(stNum_show)],...
            'fontweight','normal');
    end
end
%==========================
% Display "notes" if exists.
%==========================
exist notes;
if ans==1, notes, end


